PAGE        66,132
;
;          This routine serves the same function as GIVEBACK.ASM
;          (by Kurt Riegel ASTRO Bulletin Board 703-522-8945)
;          only this routine is for *Desqview* users.
;          When this routine is called it causes DV to give up the
;          rest of the time slice in that window. DVSLICE will
;          speed up operations in all other windows when called.
;          If you are running two nodes, and one is waiting for a
;          call, the other nodes speed is greatly increased. This
;          goes for other programs as well.
;          To see the difference in speed, Z)oom your RBBS window
;          to the top half of the screen, open up a DOS window on
;          the bottom, and TYPE a large text file in the dos window
;          Then while the RBBS is waiting for a call hit ESC to
;          log-on then hit [ENTER] to abort your log-on, you should
;          already notice a difference in speed in the TYPE'd file.
;          When RBBS is back to the point where it is waiting for a
;          call, the TYPE'd file will speed up again!
;
;          There are two areas in RBBSSUB1 that use DVSLICE. These
;          are the same points used by Kurt's GIVEBACK.ASM:
;
;   Change line 266 to read like so:
;
;   266   IF (INP(MODEM.STATUS.REGISTER) AND &H40) > 0 AND _
;            REQUIRED.RINGS > 0 THEN _
;            GOTO 276
;         CALL DVSLICE
;
;   Change line 1526 to read like this:
;
;   1526 Y$ = KEY.PRESSED$
;        IF Y$ <> "" THEN _
;           GOTO 1545
;        CALL DVSLICE
;        GOTO 1525
;
;   Now, just add DVSLICE in your link step and you are ready to go!
;
;   See if you van find any more wasteful areas in the RBBS code, And let
;   me and every know of what you have found.
;
;                John Morris
;                The Reno RBBS
;                702-673-3387
;

DV_SLICE SEGMENT 'CODE'
		  ASSUME CS:DV_SLICE

		  PUBLIC DVSLICE

IN_DV       DB 1                          ;are we in DV (yes!)

API_CALL  PROC
		  PUSH   AX
		  MOV    AX,101AH
		  INT    15H
		  MOV    AX,BX
		  INT    15H
		  MOV    AX,1025H
		  INT    15H
		  POP    AX
		  RET
API_CALL  ENDP

DVSLICE   PROC   FAR
		  CMP    CS:IN_DV,1
		  JNE    DVSEND
		  PUSH   BX
		  MOV    BX,1000H
		  CALL   API_CALL
		  POP    BX
DVSEND:
		  RET
DVSLICE   ENDP
DV_SLICE  ENDS
		  END

